var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { createRenderEffect, sharedConfig, createSignal, createRoot, onCleanup, createContext, useContext, createComponent, createMemo, createEffect, createUniqueId, onMount, For, Show, batch, $PROXY, getListener } from "solid-js";
import tinykeys from "tinykeys";
import Fuse from "fuse.js";
function reconcileArrays(parentNode, a, b) {
  let bLength = b.length, aEnd = a.length, bEnd = bLength, aStart = 0, bStart = 0, after = a[aEnd - 1].nextSibling, map = null;
  while (aStart < aEnd || bStart < bEnd) {
    if (a[aStart] === b[bStart]) {
      aStart++;
      bStart++;
      continue;
    }
    while (a[aEnd - 1] === b[bEnd - 1]) {
      aEnd--;
      bEnd--;
    }
    if (aEnd === aStart) {
      const node = bEnd < bLength ? bStart ? b[bStart - 1].nextSibling : b[bEnd - bStart] : after;
      while (bStart < bEnd)
        parentNode.insertBefore(b[bStart++], node);
    } else if (bEnd === bStart) {
      while (aStart < aEnd) {
        if (!map || !map.has(a[aStart]))
          a[aStart].remove();
        aStart++;
      }
    } else if (a[aStart] === b[bEnd - 1] && b[bStart] === a[aEnd - 1]) {
      const node = a[--aEnd].nextSibling;
      parentNode.insertBefore(b[bStart++], a[aStart++].nextSibling);
      parentNode.insertBefore(b[--bEnd], node);
      a[aEnd] = b[bEnd];
    } else {
      if (!map) {
        map = new Map();
        let i = bStart;
        while (i < bEnd)
          map.set(b[i], i++);
      }
      const index = map.get(a[aStart]);
      if (index != null) {
        if (bStart < index && index < bEnd) {
          let i = aStart, sequence = 1, t;
          while (++i < aEnd && i < bEnd) {
            if ((t = map.get(a[i])) == null || t !== index + sequence)
              break;
            sequence++;
          }
          if (sequence > index - bStart) {
            const node = a[aStart];
            while (bStart < index)
              parentNode.insertBefore(b[bStart++], node);
          } else
            parentNode.replaceChild(b[bStart++], a[aStart++]);
        } else
          aStart++;
      } else
        a[aStart++].remove();
    }
  }
}
const $$EVENTS = "_$DX_DELEGATE";
function template(html, check, isSVG) {
  const t = document.createElement("template");
  t.innerHTML = html;
  let node = t.content.firstChild;
  if (isSVG)
    node = node.firstChild;
  return node;
}
function delegateEvents(eventNames, document2 = window.document) {
  const e = document2[$$EVENTS] || (document2[$$EVENTS] = new Set());
  for (let i = 0, l = eventNames.length; i < l; i++) {
    const name = eventNames[i];
    if (!e.has(name)) {
      e.add(name);
      document2.addEventListener(name, eventHandler);
    }
  }
}
function setAttribute(node, name, value) {
  if (value == null)
    node.removeAttribute(name);
  else
    node.setAttribute(name, value);
}
function classList(node, value, prev = {}) {
  const classKeys = Object.keys(value || {}), prevKeys = Object.keys(prev);
  let i, len;
  for (i = 0, len = prevKeys.length; i < len; i++) {
    const key = prevKeys[i];
    if (!key || key === "undefined" || value[key])
      continue;
    toggleClassKey(node, key, false);
    delete prev[key];
  }
  for (i = 0, len = classKeys.length; i < len; i++) {
    const key = classKeys[i], classValue = !!value[key];
    if (!key || key === "undefined" || prev[key] === classValue || !classValue)
      continue;
    toggleClassKey(node, key, true);
    prev[key] = classValue;
  }
  return prev;
}
function insert(parent, accessor, marker, initial) {
  if (marker !== void 0 && !initial)
    initial = [];
  if (typeof accessor !== "function")
    return insertExpression(parent, accessor, initial, marker);
  createRenderEffect((current) => insertExpression(parent, accessor(), current, marker), initial);
}
function toggleClassKey(node, key, value) {
  const classNames = key.trim().split(/\s+/);
  for (let i = 0, nameLen = classNames.length; i < nameLen; i++)
    node.classList.toggle(classNames[i], value);
}
function eventHandler(e) {
  const key = `$$${e.type}`;
  let node = e.composedPath && e.composedPath()[0] || e.target;
  if (e.target !== node) {
    Object.defineProperty(e, "target", {
      configurable: true,
      value: node
    });
  }
  Object.defineProperty(e, "currentTarget", {
    configurable: true,
    get() {
      return node || document;
    }
  });
  while (node !== null) {
    const handler = node[key];
    if (handler && !node.disabled) {
      const data = node[`${key}Data`];
      data !== void 0 ? handler(data, e) : handler(e);
      if (e.cancelBubble)
        return;
    }
    node = node.host && node.host !== node && node.host instanceof Node ? node.host : node.parentNode;
  }
}
function insertExpression(parent, value, current, marker, unwrapArray) {
  if (sharedConfig.context && !current)
    current = [...parent.childNodes];
  while (typeof current === "function")
    current = current();
  if (value === current)
    return current;
  const t = typeof value, multi = marker !== void 0;
  parent = multi && current[0] && current[0].parentNode || parent;
  if (t === "string" || t === "number") {
    if (t === "number")
      value = value.toString();
    if (multi) {
      let node = current[0];
      if (node && node.nodeType === 3) {
        node.data = value;
      } else
        node = document.createTextNode(value);
      current = cleanChildren(parent, current, marker, node);
    } else {
      if (current !== "" && typeof current === "string") {
        current = parent.firstChild.data = value;
      } else
        current = parent.textContent = value;
    }
  } else if (value == null || t === "boolean") {
    if (sharedConfig.context)
      return current;
    current = cleanChildren(parent, current, marker);
  } else if (t === "function") {
    createRenderEffect(() => {
      let v = value();
      while (typeof v === "function")
        v = v();
      current = insertExpression(parent, v, current, marker);
    });
    return () => current;
  } else if (Array.isArray(value)) {
    const array = [];
    if (normalizeIncomingArray(array, value, unwrapArray)) {
      createRenderEffect(() => current = insertExpression(parent, array, current, marker, true));
      return () => current;
    }
    if (sharedConfig.context && current && current.length) {
      for (let i = 0; i < array.length; i++) {
        if (array[i].parentNode)
          return current = array;
      }
      return current;
    }
    if (array.length === 0) {
      current = cleanChildren(parent, current, marker);
      if (multi)
        return current;
    } else {
      if (Array.isArray(current)) {
        if (current.length === 0) {
          appendNodes(parent, array, marker);
        } else
          reconcileArrays(parent, current, array);
      } else if (current == null || current === "") {
        appendNodes(parent, array);
      } else {
        reconcileArrays(parent, multi && current || [parent.firstChild], array);
      }
    }
    current = array;
  } else if (value instanceof Node) {
    if (sharedConfig.context)
      return current = value.parentNode ? multi ? [value] : value : current;
    if (Array.isArray(current)) {
      if (multi)
        return current = cleanChildren(parent, current, marker, value);
      cleanChildren(parent, current, null, value);
    } else if (current == null || current === "" || !parent.firstChild) {
      parent.appendChild(value);
    } else
      parent.replaceChild(value, parent.firstChild);
    current = value;
  } else
    ;
  return current;
}
function normalizeIncomingArray(normalized, array, unwrap2) {
  let dynamic = false;
  for (let i = 0, len = array.length; i < len; i++) {
    let item = array[i], t;
    if (item instanceof Node) {
      normalized.push(item);
    } else if (item == null || item === true || item === false)
      ;
    else if (Array.isArray(item)) {
      dynamic = normalizeIncomingArray(normalized, item) || dynamic;
    } else if ((t = typeof item) === "string") {
      normalized.push(document.createTextNode(item));
    } else if (t === "function") {
      if (unwrap2) {
        while (typeof item === "function")
          item = item();
        dynamic = normalizeIncomingArray(normalized, Array.isArray(item) ? item : [item]) || dynamic;
      } else {
        normalized.push(item);
        dynamic = true;
      }
    } else
      normalized.push(document.createTextNode(item.toString()));
  }
  return dynamic;
}
function appendNodes(parent, array, marker) {
  for (let i = 0, len = array.length; i < len; i++)
    parent.insertBefore(array[i], marker);
}
function cleanChildren(parent, current, marker, replacement) {
  if (marker === void 0)
    return parent.textContent = "";
  const node = replacement || document.createTextNode("");
  if (current.length) {
    let inserted = false;
    for (let i = current.length - 1; i >= 0; i--) {
      const el = current[i];
      if (node !== el) {
        const isParent = el.parentNode === parent;
        if (!inserted && !i)
          isParent ? parent.replaceChild(node, el) : parent.insertBefore(node, marker);
        else
          isParent && el.remove();
      } else
        inserted = true;
    }
  } else
    parent.insertBefore(node, marker);
  return [node];
}
const SVG_NAMESPACE = "http://www.w3.org/2000/svg";
function createElement(tagName, isSVG = false) {
  return isSVG ? document.createElementNS(SVG_NAMESPACE, tagName) : document.createElement(tagName);
}
function Portal(props) {
  const {
    useShadow
  } = props, marker = document.createTextNode(""), mount = props.mount || document.body;
  function renderPortal() {
    if (sharedConfig.context) {
      const [s, set] = createSignal(false);
      queueMicrotask(() => set(true));
      return () => s() && props.children;
    } else
      return () => props.children;
  }
  if (mount instanceof HTMLHeadElement) {
    const [clean, setClean] = createSignal(false);
    const cleanup = () => setClean(true);
    createRoot((dispose) => insert(mount, () => !clean() ? renderPortal()() : dispose(), null));
    onCleanup(() => {
      if (sharedConfig.context)
        queueMicrotask(cleanup);
      else
        cleanup();
    });
  } else {
    const container = createElement(props.isSVG ? "g" : "div", props.isSVG), renderRoot = useShadow && container.attachShadow ? container.attachShadow({
      mode: "open"
    }) : container;
    Object.defineProperty(container, "host", {
      get() {
        return marker.parentNode;
      }
    });
    insert(renderRoot, renderPortal());
    mount.appendChild(container);
    props.ref && props.ref(container);
    onCleanup(() => mount.removeChild(container));
  }
  return marker;
}
const storeContext = createContext();
const Provider = storeContext.Provider;
function useStore() {
  const store = useContext(storeContext);
  return store;
}
const CommandPalettePortal = (p) => {
  let portalElem = null;
  createRenderEffect(() => {
    if (portalElem) {
      return;
    }
    const parent = document.body;
    const newPortalElem = document.createElement("div");
    newPortalElem.classList.add("command-palette-portal");
    parent.appendChild(newPortalElem);
    portalElem = newPortalElem;
  });
  onCleanup(() => {
    if (portalElem) {
      portalElem.remove();
      portalElem = null;
    }
  });
  return createComponent(Portal, {
    mount: portalElem,
    get children() {
      return p.children;
    }
  });
};
const kbdShortcut = "_kbdShortcut_1w73e_1";
var styles$1 = {
  kbdShortcut
};
const _tmpl$$2 = template(`<kbd></kbd>`);
const modifierKey = /Mac|iPod|iPhone|iPad/.test(navigator.platform) ? "cmd" : "control";
const KbdShortcut = (p) => {
  const shortcut = p.shortcut.replaceAll("$mod", modifierKey);
  return (() => {
    const _el$ = _tmpl$$2.cloneNode(true);
    insert(_el$, shortcut);
    createRenderEffect(() => _el$.className = styles$1.kbdShortcut);
    return _el$;
  })();
};
function createActionList() {
  const [state] = useStore();
  const actionsList = createMemo(() => {
    return Object.values(state.actions);
  });
  return actionsList;
}
function createConditionalActionList() {
  const [state] = useStore();
  const actionsList = createActionList();
  const conditionalActionList = createMemo(() => {
    function checkActionAllowed(action) {
      if (!action.cond) {
        return true;
      }
      const isAllowed = action.cond({ actionId: action.id, actionsContext: state.actionsContext });
      return isAllowed;
    }
    const conditionalActionList2 = actionsList().filter(checkActionAllowed);
    return conditionalActionList2;
  });
  return conditionalActionList;
}
function createSearchResultList() {
  const [state] = useStore();
  const conditionalActionList = createConditionalActionList();
  const fuse = new Fuse(conditionalActionList(), {
    keys: [
      {
        name: "title",
        weight: 1
      },
      {
        name: "subtitle",
        weight: 0.7
      },
      {
        name: "keywords",
        weight: 0.5
      }
    ]
  });
  const resultsList = createMemo(() => {
    if (state.searchText.length === 0) {
      return conditionalActionList();
    }
    const searchResults = fuse.search(state.searchText);
    const resultsList2 = searchResults.map((result) => result.item);
    return resultsList2;
  });
  createEffect(() => {
    fuse.setCollection(conditionalActionList());
  });
  return resultsList;
}
const visuallyHidden = "_visuallyHidden_2b3bg_1";
const boxBorder = "_boxBorder_2b3bg_14";
const stripSpace = "_stripSpace_2b3bg_18";
var utilStyles = {
  visuallyHidden,
  boxBorder,
  stripSpace
};
const wrapper = "_wrapper_10num_1";
const palette = "_palette_10num_8";
const searchInput = "_searchInput_10num_29";
const resultWrapper = "_resultWrapper_10num_38";
const resultList = "_resultList_10num_43";
const resultItem = "_resultItem_10num_47";
const activeItem = "_activeItem_10num_57";
const resultTitle = "_resultTitle_10num_61";
const resultSubtitle = "_resultSubtitle_10num_61";
var styles = {
  wrapper,
  palette,
  "anim-fade-in": "_anim-fade-in_10num_1",
  searchInput,
  resultWrapper,
  resultList,
  resultItem,
  activeItem,
  resultTitle,
  resultSubtitle
};
const _tmpl$$1 = template(`<div><div><div><label>Search for an action and then select one of the option.</label><input type="search" placeholder="Type a command or search..." data-cp-kbd-shortcuts="disabled"></div><div><ul role="listbox"></ul></div></div></div>`), _tmpl$2 = template(`<div><h4>Couldn't find any matching actions</h4></div>`), _tmpl$3 = template(`<p></p>`), _tmpl$4 = template(`<li role="option"><div><h4></h4></div><div></div></li>`);
const CommandPaletteInternal = () => {
  const [state, {
    closePalette,
    setSearchText
  }] = useStore();
  const resultsList = createSearchResultList();
  const [activeItemId, setActiveItemId] = createSignal(null);
  const searchLabelId = createUniqueId();
  const searchInputId = createUniqueId();
  let wrapperElem;
  let paletteElem;
  let searchInputElem;
  function triggerRun(action) {
    action.run({
      actionId: action.id,
      actionsContext: state.actionsContext
    });
  }
  function handleWrapperClick() {
    closePalette();
  }
  function handlePaletteClick(event) {
    event.stopPropagation();
  }
  const handleSearchInput = (event) => {
    const newValue = event.currentTarget.value;
    setSearchText(newValue);
  };
  function handleActionItemSelect(action) {
    triggerRun(action);
  }
  function handleKbdEnter(event) {
    event.preventDefault();
    const activeActionId = activeItemId();
    if (!activeActionId) {
      return null;
    }
    const action = state.actions[activeActionId];
    triggerRun(action);
  }
  function handleKbdPrev(event) {
    event.preventDefault();
    const actionsList = resultsList();
    const actionsCount = actionsList.length;
    const activeActionId = activeItemId();
    const currentActionIndex = actionsList.findIndex((action) => action.id === activeActionId);
    const prevActionIndex = (actionsCount + currentActionIndex - 1) % actionsCount;
    const prevActionId = actionsList[prevActionIndex].id;
    setActiveItemId(prevActionId);
  }
  function handleKbdNext(event) {
    event.preventDefault();
    const actionsList = resultsList();
    const actionsCount = actionsList.length;
    const activeActionId = activeItemId();
    const currentActionIndex = actionsList.findIndex((action) => action.id === activeActionId);
    const nextActionIndex = (currentActionIndex + 1) % actionsCount;
    const nextActionId = actionsList[nextActionIndex].id;
    setActiveItemId(nextActionId);
  }
  function handleActionItemHover(action) {
    setActiveItemId(action.id);
  }
  onMount(() => {
    searchInputElem.select();
    tinykeys(wrapperElem, {
      Escape: () => {
        closePalette();
      },
      Enter: handleKbdEnter,
      ArrowUp: handleKbdPrev,
      ArrowDown: handleKbdNext
    });
  });
  createEffect(() => {
    var _a;
    const actionsList = resultsList();
    const firstResultId = (_a = actionsList[0]) == null ? void 0 : _a.id;
    if (firstResultId) {
      setActiveItemId(firstResultId);
    } else {
      setActiveItemId(null);
    }
  });
  return (() => {
    const _el$ = _tmpl$$1.cloneNode(true), _el$2 = _el$.firstChild, _el$3 = _el$2.firstChild, _el$4 = _el$3.firstChild, _el$5 = _el$4.nextSibling, _el$6 = _el$3.nextSibling, _el$7 = _el$6.firstChild;
    _el$.$$click = handleWrapperClick;
    const _ref$ = wrapperElem;
    typeof _ref$ === "function" ? _ref$(_el$) : wrapperElem = _el$;
    _el$2.$$click = handlePaletteClick;
    const _ref$2 = paletteElem;
    typeof _ref$2 === "function" ? _ref$2(_el$2) : paletteElem = _el$2;
    setAttribute(_el$4, "for", searchInputId);
    setAttribute(_el$4, "id", searchLabelId);
    _el$5.$$input = handleSearchInput;
    const _ref$3 = searchInputElem;
    typeof _ref$3 === "function" ? _ref$3(_el$5) : searchInputElem = _el$5;
    setAttribute(_el$5, "id", searchInputId);
    setAttribute(_el$7, "aria-labelledby", searchInputId);
    insert(_el$7, createComponent(For, {
      get each() {
        return resultsList();
      },
      get fallback() {
        return (() => {
          const _el$8 = _tmpl$2.cloneNode(true), _el$9 = _el$8.firstChild;
          createRenderEffect((_p$) => {
            const _v$8 = styles.resultItem, _v$9 = `${styles.resultTitle} ${utilStyles.stripSpace}`;
            _v$8 !== _p$._v$8 && (_el$8.className = _p$._v$8 = _v$8);
            _v$9 !== _p$._v$9 && (_el$9.className = _p$._v$9 = _v$9);
            return _p$;
          }, {
            _v$8: void 0,
            _v$9: void 0
          });
          return _el$8;
        })();
      },
      children: (action) => {
        return (() => {
          const _el$10 = _tmpl$4.cloneNode(true), _el$11 = _el$10.firstChild, _el$12 = _el$11.firstChild, _el$14 = _el$11.nextSibling;
          _el$10.addEventListener("mouseenter", (e) => handleActionItemHover(action));
          _el$10.$$click = handleActionItemSelect;
          _el$10.$$clickData = action;
          insert(_el$12, () => action.title);
          insert(_el$11, createComponent(Show, {
            get when() {
              return action.subtitle;
            },
            get children() {
              const _el$13 = _tmpl$3.cloneNode(true);
              insert(_el$13, () => action.subtitle);
              createRenderEffect(() => _el$13.className = `${styles.resultSubtitle} ${utilStyles.stripSpace}`);
              return _el$13;
            }
          }), null);
          insert(_el$14, createComponent(Show, {
            get when() {
              return action.shortcut;
            },
            get children() {
              return createComponent(KbdShortcut, {
                get shortcut() {
                  return action.shortcut;
                }
              });
            }
          }));
          createRenderEffect((_p$) => {
            const _v$10 = `${styles.resultItem} ${utilStyles.boxBorder}`, _v$11 = {
              [styles.activeItem]: action.id === activeItemId()
            }, _v$12 = action.id === activeItemId(), _v$13 = `${styles.resultTitle} ${utilStyles.stripSpace}`;
            _v$10 !== _p$._v$10 && (_el$10.className = _p$._v$10 = _v$10);
            _p$._v$11 = classList(_el$10, _v$11, _p$._v$11);
            _v$12 !== _p$._v$12 && setAttribute(_el$10, "aria-selected", _p$._v$12 = _v$12);
            _v$13 !== _p$._v$13 && (_el$12.className = _p$._v$13 = _v$13);
            return _p$;
          }, {
            _v$10: void 0,
            _v$11: void 0,
            _v$12: void 0,
            _v$13: void 0
          });
          return _el$10;
        })();
      }
    }));
    createRenderEffect((_p$) => {
      const _v$ = styles.wrapper, _v$2 = styles.palette, _v$3 = utilStyles.visuallyHidden, _v$4 = `${styles.searchInput} ${utilStyles.boxBorder}`, _v$5 = state.searchText, _v$6 = styles.resultWrapper, _v$7 = `${styles.resultList} ${utilStyles.stripSpace}`;
      _v$ !== _p$._v$ && (_el$.className = _p$._v$ = _v$);
      _v$2 !== _p$._v$2 && (_el$2.className = _p$._v$2 = _v$2);
      _v$3 !== _p$._v$3 && (_el$4.className = _p$._v$3 = _v$3);
      _v$4 !== _p$._v$4 && (_el$5.className = _p$._v$4 = _v$4);
      _v$5 !== _p$._v$5 && (_el$5.value = _p$._v$5 = _v$5);
      _v$6 !== _p$._v$6 && (_el$6.className = _p$._v$6 = _v$6);
      _v$7 !== _p$._v$7 && (_el$7.className = _p$._v$7 = _v$7);
      return _p$;
    }, {
      _v$: void 0,
      _v$2: void 0,
      _v$3: void 0,
      _v$4: void 0,
      _v$5: void 0,
      _v$6: void 0,
      _v$7: void 0
    });
    return _el$;
  })();
};
const CommandPalette = () => {
  const [state] = useStore();
  return createComponent(CommandPalettePortal, {
    get children() {
      return createComponent(Show, {
        get when() {
          return state.visibility === "opened";
        },
        get children() {
          return createComponent(CommandPaletteInternal, {});
        }
      });
    }
  });
};
delegateEvents(["click", "input"]);
const $RAW = Symbol("store-raw"), $NODE = Symbol("store-node"), $NAME = Symbol("store-name");
function wrap$1(value, name) {
  let p = value[$PROXY];
  if (!p) {
    Object.defineProperty(value, $PROXY, {
      value: p = new Proxy(value, proxyTraps$1)
    });
    const keys = Object.keys(value), desc = Object.getOwnPropertyDescriptors(value);
    for (let i = 0, l = keys.length; i < l; i++) {
      const prop = keys[i];
      if (desc[prop].get) {
        const get = desc[prop].get.bind(p);
        Object.defineProperty(value, prop, {
          get
        });
      }
    }
  }
  return p;
}
function isWrappable(obj) {
  return obj != null && typeof obj === "object" && (obj[$PROXY] || !obj.__proto__ || obj.__proto__ === Object.prototype || Array.isArray(obj));
}
function unwrap(item, set = new Set()) {
  let result, unwrapped, v, prop;
  if (result = item != null && item[$RAW])
    return result;
  if (!isWrappable(item) || set.has(item))
    return item;
  if (Array.isArray(item)) {
    if (Object.isFrozen(item))
      item = item.slice(0);
    else
      set.add(item);
    for (let i = 0, l = item.length; i < l; i++) {
      v = item[i];
      if ((unwrapped = unwrap(v, set)) !== v)
        item[i] = unwrapped;
    }
  } else {
    if (Object.isFrozen(item))
      item = Object.assign({}, item);
    else
      set.add(item);
    const keys = Object.keys(item), desc = Object.getOwnPropertyDescriptors(item);
    for (let i = 0, l = keys.length; i < l; i++) {
      prop = keys[i];
      if (desc[prop].get)
        continue;
      v = item[prop];
      if ((unwrapped = unwrap(v, set)) !== v)
        item[prop] = unwrapped;
    }
  }
  return item;
}
function getDataNodes(target) {
  let nodes = target[$NODE];
  if (!nodes)
    Object.defineProperty(target, $NODE, {
      value: nodes = {}
    });
  return nodes;
}
function proxyDescriptor(target, property) {
  const desc = Reflect.getOwnPropertyDescriptor(target, property);
  if (!desc || desc.get || !desc.configurable || property === $PROXY || property === $NODE || property === $NAME)
    return desc;
  delete desc.value;
  delete desc.writable;
  desc.get = () => target[$PROXY][property];
  return desc;
}
function ownKeys(target) {
  if (getListener()) {
    const nodes = getDataNodes(target);
    (nodes._ || (nodes._ = createDataNode()))();
  }
  return Reflect.ownKeys(target);
}
function createDataNode() {
  const [s, set] = createSignal(void 0, {
    equals: false,
    internal: true
  });
  s.$ = set;
  return s;
}
const proxyTraps$1 = {
  get(target, property, receiver) {
    if (property === $RAW)
      return target;
    if (property === $PROXY)
      return receiver;
    const value = target[property];
    if (property === $NODE || property === "__proto__")
      return value;
    const wrappable = isWrappable(value);
    if (getListener() && (typeof value !== "function" || target.hasOwnProperty(property))) {
      let nodes, node;
      if (wrappable && (nodes = getDataNodes(value))) {
        node = nodes._ || (nodes._ = createDataNode());
        node();
      }
      nodes = getDataNodes(target);
      node = nodes[property] || (nodes[property] = createDataNode());
      node();
    }
    return wrappable ? wrap$1(value) : value;
  },
  set() {
    return true;
  },
  deleteProperty() {
    return true;
  },
  ownKeys,
  getOwnPropertyDescriptor: proxyDescriptor
};
function setProperty(state, property, value) {
  if (state[property] === value)
    return;
  const array = Array.isArray(state);
  const len = state.length;
  const isUndefined = value === void 0;
  const notify = array || isUndefined === property in state;
  if (isUndefined) {
    delete state[property];
  } else
    state[property] = value;
  let nodes = getDataNodes(state), node;
  (node = nodes[property]) && node.$();
  if (array && state.length !== len)
    (node = nodes.length) && node.$();
  notify && (node = nodes._) && node.$();
}
function mergeStoreNode(state, value) {
  const keys = Object.keys(value);
  for (let i = 0; i < keys.length; i += 1) {
    const key = keys[i];
    setProperty(state, key, value[key]);
  }
}
function updatePath(current, path, traversed = []) {
  let part, prev = current;
  if (path.length > 1) {
    part = path.shift();
    const partType = typeof part, isArray = Array.isArray(current);
    if (Array.isArray(part)) {
      for (let i = 0; i < part.length; i++) {
        updatePath(current, [part[i]].concat(path), [part[i]].concat(traversed));
      }
      return;
    } else if (isArray && partType === "function") {
      for (let i = 0; i < current.length; i++) {
        if (part(current[i], i))
          updatePath(current, [i].concat(path), [i].concat(traversed));
      }
      return;
    } else if (isArray && partType === "object") {
      const {
        from = 0,
        to = current.length - 1,
        by = 1
      } = part;
      for (let i = from; i <= to; i += by) {
        updatePath(current, [i].concat(path), [i].concat(traversed));
      }
      return;
    } else if (path.length > 1) {
      updatePath(current[part], path, [part].concat(traversed));
      return;
    }
    prev = current[part];
    traversed = [part].concat(traversed);
  }
  let value = path[0];
  if (typeof value === "function") {
    value = value(prev, traversed);
    if (value === prev)
      return;
  }
  if (part === void 0 && value == void 0)
    return;
  value = unwrap(value);
  if (part === void 0 || isWrappable(prev) && isWrappable(value) && !Array.isArray(value)) {
    mergeStoreNode(prev, value);
  } else
    setProperty(current, part, value);
}
function createStore(store, options) {
  const unwrappedStore = unwrap(store || {});
  const wrappedStore = wrap$1(unwrappedStore);
  function setStore(...args) {
    batch(() => updatePath(unwrappedStore, args));
  }
  return [wrappedStore, setStore];
}
function createShortcutHandlersMap(actionsList, actionsContext) {
  const shortcutMap = {};
  actionsList.filter((action) => Boolean(action.shortcut)).forEach((action) => {
    const actionHandler = (event) => {
      const targetElem = event.target;
      const shortcutsAttr = targetElem.dataset.cpKbdShortcuts;
      if (shortcutsAttr === "disabled") {
        return;
      }
      event.preventDefault();
      action.run({ actionId: action.id, actionsContext });
    };
    shortcutMap[action.shortcut] = actionHandler;
  });
  return shortcutMap;
}
function createKbdShortcuts() {
  const [state, { togglePalette }] = useStore();
  const actionsList = createActionList();
  let unsubscribe = null;
  onMount(() => {
    const shortcutMap = createShortcutHandlersMap(actionsList(), state.actionsContext);
    const commandPaletteHandler = (event) => {
      event.preventDefault();
      togglePalette();
    };
    unsubscribe = tinykeys(window, __spreadProps(__spreadValues({}, shortcutMap), {
      "$mod+k": commandPaletteHandler
    }));
  });
  onCleanup(() => {
    if (unsubscribe) {
      unsubscribe();
    }
  });
}
const _tmpl$ = template(`<div></div>`);
const RootInternal = () => {
  createKbdShortcuts();
  return null;
};
const Root = (p) => {
  const initialActions = p.actions || {};
  const initialActionsContext = p.actionsContext || {};
  const [state, setState] = createStore({
    visibility: "closed",
    searchText: "",
    actions: initialActions,
    actionsContext: initialActionsContext
  });
  const storeMethods = {
    openPalette() {
      setState("visibility", "opened");
    },
    closePalette() {
      setState("visibility", "closed");
    },
    togglePalette() {
      setState("visibility", (prev) => prev === "opened" ? "closed" : "opened");
    },
    setSearchText(newValue) {
      setState("searchText", newValue);
    }
  };
  const store = [state, storeMethods];
  return createComponent(Provider, {
    value: store,
    get children() {
      const _el$ = _tmpl$.cloneNode(true);
      insert(_el$, createComponent(RootInternal, {}), null);
      insert(_el$, () => p.children, null);
      return _el$;
    }
  });
};
const defaultRun = ({ actionId }) => {
  console.warn(`The triggered action doesn't have a run function. It'll be a noop in production`, {
    actionId
  });
};
const defineAction = (partialAction) => {
  const id = partialAction.id || Math.random().toString();
  const title = partialAction.title;
  const subtitle = partialAction.subtitle || null;
  const keywords = partialAction.keywords || [];
  const shortcut = partialAction.shortcut || null;
  const run = partialAction.run || defaultRun;
  const normalizedAction = {
    id,
    title,
    subtitle,
    keywords,
    shortcut,
    cond: partialAction.cond,
    run
  };
  return normalizedAction;
};
export { CommandPalette, CommandPaletteInternal, Root, defineAction };
